#include <gtk/gtk.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"
#include "cb_wintool.h"

static int ToolSelect = 1;

/*
	ġС.إץܥ
*/
void
On_btnTMenuHelp_Clicked( GtkButton *button,gpointer user_data )
{
#if 0
	char cmd[ 256 ];
	FILE *fout;
	strcpy( cmd,STR_PCTOOLHELP );
	strcat( cmd," " );
/*	strcat( cmd,STR_PCTOOLHELP_TOOL );*/
	strcat( cmd,STR_HELP_TOOL );			/*add 03/26*/
	fout = popen( cmd,"r" );
	pclose( fout );
#endif

	unsigned char ucFileName[1024];	/*̎̾*/
	unsigned char ucCmd[1024];		/*ώݎĎގ׎*/
	unsigned char buff[1024];
	FILE *fp;
	HELP_LOC_UDT help_loc;
	int iCheckFlag;
	int iRtnCd;
	
	/**/
	iCheckFlag = 0;
	memset(help_loc.loc_default,0x00,1024-1);
	memset(help_loc.loc_ja,0x00,1024-1);
	strncpy(help_loc.loc_default,STR_HELP_TOOL,1024-1);
	strncpy(help_loc.loc_ja,STR_HELP_TOOLJA,1024-1);

	iRtnCd = SelectHelpByLocale(ucFileName,&help_loc);
	if(-1 != iRtnCd) {

		/*ŵư*/
		fp = popen(CMDPS,"r");
		while(fgets(buff,1024,fp) != NULL) {
			if(strstr(buff,STR_START_NN)) {
				iCheckFlag = 1;
				break;
			}
		}
		pclose(fp);

		/*َ͎̎ɽ*/
		if(0 == iCheckFlag) {
			/*̎ގ׎޵ư܎َ͎̎ɽ*/
			snprintf(ucCmd,1024-1,"%s file:%s &",STR_START_NN,ucFileName);
		} else if(1 == iCheckFlag) {
			/*َ͎̎ɽ*/
			snprintf(ucCmd,1024-1,"%s -remote \'openFile(%s)\' &",STR_START_NN,ucFileName);
		}

		fp = popen(ucCmd,"r");
		pclose(fp);
	}

	return;
}

/*
	ġС.ܥ
*/
void
On_btnTBReturn_Clicked(  GtkButton *button,gpointer user_data )
{
	ToolSelect = 1;
	gtk_widget_destroy(
		gtk_widget_get_toplevel( GTK_WIDGET( button ) )
	);

	InitWintop();

	return;
}

/*
	¹.fsckܥ
*/
void
On_btnTExeFck_Clicked( GtkButton *button,gpointer user_data )
{
	char *cmdFsckmsdos[] = { CMDSUDO,CMDFSCK,NULL,NULL };
	char *cmdCkmount[]   = { CMDSUDO,CMDMOUNT,NULL };
	char *cmdUmount[]    = { CMDSUDO,CMDUMOUNT,NULL,NULL };
	char *cmdMount[]     = { CMDSUDO,CMDMOUNT,"-o","gid=100,uid=100","-t","vfat",NULL,NULL,NULL };
	char *buff_out,*buff_err;
	char *pSocket,*pDevice;
	char *Device;
	char DeviceName[ 14 ];
	char Socket[ 9 ];
	char MountPoint[ 16 ];
	int  MountFlg=-1;
	int  rtnCd;
	int  i;

	rtnCd = ToolSelect;
	switch( rtnCd ) {
	case 1:
		strcpy( DeviceName,NAME_DEVICE_FDD );
		strcpy( MountPoint,STR_MPFDD );
		break;
	case 2:
		strcpy( Socket,STR_SOCKET0);
		strcpy( MountPoint,STR_MPS0 );
		break;
	case 3:
		strcpy( Socket,STR_SOCKET1);
		strcpy( MountPoint,STR_MPS1 );
		break;
	}

	if( rtnCd != 1 ) {
		switch( GetSocketInfo( rtnCd - 2 ) ) {
		case FUNC_LAN:
		case FUNC_OTHER:
			Show_Msg( 1,TITLE_FSCK,MSG_NOTDO_NOIDE );
			return;
			break;
		case FUNC_NOCARD:
			Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
			return;
			break;
		}
	}

	if( ExecCmd( cmdCkmount ) != -1 ) {
		if( ReadExecFile( EXEERR,&buff_err ) ) {
			free( buff_err );
			Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
			return;
		}
		free( buff_err );

		MountFlg = 0;
		ReadExecFile( EXEOUT,&buff_out );
		if( strstr( buff_out,MountPoint ) ) {
			if( rtnCd == 1 ) {
				Show_Msg( 1,TITLE_FSCK,MSG_NOTDO_MOUNTED );
				free( buff_out );
				return;
			} else if( rtnCd == 2 || rtnCd == 3 ) {
				if( Show_Msg( 2,TITLE_FSCK,MSG_UMOUNT ) ) {
					free( buff_out );
					cmdUmount[2] = MountPoint;
					if( ExecCmd( cmdUmount ) != -1 ) {
						MountFlg = 1;
						if( ReadExecFile( EXEERR,&buff_err ) ) {
							free( buff_err );
							Show_Msg( 1,TITLE_FSCK,MSG_NOTDO_USED );
							return;
						}
						free( buff_err );
					} else {
						Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
						return;
					}
				} else {
					Show_Msg( 1,TITLE_FSCK,MSG_DOSTOP );
					free( buff_out );
					return;
				}
			}
		} else {
			free( buff_out );
		}
	} else {
		Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
		return;
	}

	if( rtnCd != 1 ) {
		if( GetDeviceName( rtnCd - 2,&Device ) == 0 ) {
			strcpy( DeviceName,Device );
			strcat( DeviceName,"1" );
			free( Device );
		} else {
			Show_Msg( 1,TITLE_FSCK,MSG_NOTDO_NOCARD );
			return;
		}
	}

	cmdFsckmsdos[ 2 ] = DeviceName;
	if( ExecCmd( cmdFsckmsdos ) != -1 ) {
		ReadExecFile( EXEOUT,&buff_out );
		if( ReadExecFile( EXEERR,&buff_err ) ) {
			if( strstr( buff_err,STR_NODEV ) ) {
				Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
			} else if( strstr( buff_err,ERR_DIFFERFS ) ) {
				Show_Msg( 1,TITLE_FSCK,MSG_DIFFERFS );
			} else if( strstr( buff_err,STR_NOTCONFIGURED ) ) {
				Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
			} else {
				Show_Msg( 1,TITLE_FSCK,MSG_FINDERR );
			}
			free( buff_out );
			free( buff_err );
			return;
		} else {
			if( strstr( buff_out,DeviceName ) ) {
				Show_Msg( 1,TITLE_FSCK,MSG_NOERR );
				free( buff_out );
				free( buff_err );
			} else {
				Show_Msg( 1,TITLE_FSCK,MSG_FINDERR );
				free( buff_out );
				free( buff_err );
				return;
			}
		}
	} else {
		Show_Msg( 1,TITLE_FSCK,MSG_NOTDO );
		return;
	}

	if( MountFlg && ( rtnCd != 1 ) ) {
		cmdMount[ 6 ] = DeviceName;
		cmdMount[ 7 ] = MountPoint;
		if( ExecCmd( cmdMount ) != -1 ) {
			if( ReadExecFile( EXEERR,&buff_err ) ) {
				Show_Msg( 1,TITLE_FSCK,MSG_LOSTMOUNT );
				free( buff_err );
				return;
			}
			free( buff_err );
		} else {
			Show_Msg( 1,TITLE_FSCK,MSG_LOSTMOUNT );
			return;
		}
	}
}

/*
	¹.formatܥ
*/
void
On_btnTExeFmt_Clicked( GtkButton *button,gpointer user_data )
{
	char *cmdFdformat[]  = { CMDSUDO,CMDFDFORMAT,STR_FMTDRIVE,NULL };
	char *cmdMkfsmsdos[] = { CMDSUDO,CMDMKFS,"-c",NULL,NULL };
	char *cmdMount[]     = { CMDSUDO,CMDMOUNT,"-o","gid=100,uid=100","-t","vfat",NULL,NULL,NULL };
	char *cmdUmount[]    = { CMDSUDO,CMDUMOUNT,NULL,NULL };
	char *cmdShfdisk[]   = { CMDSH,PCTOOLFDISK,NULL,NULL };
	char *cmdCkmount[]   = { CMDSUDO,CMDMOUNT,NULL };
	char *buff_out,*buff_err;
	char *prtnFmt;
	char *prtnVer;
	char *pSocket,*pDevice;
	char *Device;
	char DeviceName[14];
	char Socket[9];
	char MountPoint[ 16 ];
	int  rtnCd = 0;
	int  MountFlg = -1;
	int  i = 0;

	rtnCd = Show_Msg( 2,TITLE_FMT,MSG_FMTSTART ) * ToolSelect;
	if( rtnCd == 0 ) {
		Show_Msg( 1,TITLE_FMT,MSG_DOSTOP );
		return;
	}

	if( rtnCd != 1 ) {
		switch( GetSocketInfo( rtnCd - 2 ) ) {
		case FUNC_LAN:
		case FUNC_OTHER:
			Show_Msg( 1,TITLE_FMT,MSG_NOTDO_NOIDE );
			return;
			break;
		case FUNC_NOCARD:
			Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
			return;
			break;
		}
	}

	switch( rtnCd ) {
	case  1:
		strcpy( MountPoint,STR_MPFDD );
		break;
	case  2:
		strcpy( Socket,STR_SOCKET0 );
		strcpy( MountPoint,STR_MPS0 );
		break;
	case  3:
		strcpy( Socket,STR_SOCKET1 );
		strcpy( MountPoint,STR_MPS1 );
		break;
	}

	if( ExecCmd( cmdCkmount ) != -1 ) {
		if( ReadExecFile( EXEERR,&buff_err ) ) {
			free( buff_err );
			Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
			return;
		}
		free( buff_err );

		ReadExecFile( EXEOUT,&buff_out );
		if( strstr( buff_out,MountPoint ) ) {
			if( rtnCd == 1 ) {
				Show_Msg( 1,TITLE_FMT,MSG_NOTDO_MOUNTED );
				free( buff_out );
				return;
			} else if( rtnCd == 2 || rtnCd == 3 ) {
				if( Show_Msg( 2,TITLE_FMT,MSG_UMOUNT ) ) {
					free( buff_out );
					cmdUmount[2] = MountPoint;
					if( ExecCmd( cmdUmount ) != -1 ) {
						if( ReadExecFile( EXEERR,&buff_err ) ) {
							free( buff_err );
							Show_Msg( 1,TITLE_FMT,MSG_NOTDO_USED );
							return;
						}
						free( buff_err );
					} else {
						Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
						return;
					}
				} else {
					Show_Msg( 1,TITLE_FMT,MSG_DOSTOP );
					free( buff_out );
					return;
				}
			}
		} else {
			free( buff_out );
		}
	} else {
		Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
		return;
	}

	if( rtnCd == 1 ) {
		MountFlg = 0;
		if( ExecCmd( cmdFdformat ) != -1 ) {
			if( ReadExecFile( EXEERR,&buff_err ) ){
				Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
				free( buff_err );
				return;
			}
			free( buff_err );
		} else {
			Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
			return;
		}
	} else if( rtnCd == 2 || rtnCd == 3 ) {
		MountFlg = 1;
		if( GetDeviceName( rtnCd - 2,&Device ) == 0 ) {
			strcpy( DeviceName,Device );
			cmdShfdisk[ 2 ] = DeviceName;
			free( Device );
		} else {
			Show_Msg( 1,TITLE_FMT,MSG_NOTDO_NOCARD );
			return;
		}

		if( ExecCmd( cmdShfdisk ) != -1 ) {
			ReadExecFile( EXEOUT,&buff_out );
			if( strstr( buff_out,STR_OUT_FDISK ) ) {
				Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
				free( buff_out );
				return;
			}
			free( buff_out );
		} else {
			Show_Msg( 1,TITLE_FMT,MSG_NOTDO );
			return;
		}

		strcat( DeviceName,"1" );
		if( MountFlg ) {
			cmdMount[ 6 ]   = DeviceName;
			cmdMount[ 7 ]   = MountPoint;
			if( ExecCmd( cmdMount ) != -1 ) {
				if( ReadExecFile( EXEERR,&buff_err ) ) {
					Show_Msg( 1,TITLE_FMT,MSG_LOSTMOUNT );
					free( buff_err );
					return;
				}
				free( buff_err );
			} else {
				Show_Msg( 1,TITLE_FMT,MSG_LOSTMOUNT );
				return;
			}
		}
	}

	Show_Msg( 1,TITLE_FMT,MSG_DONE );

	SetTopFdd();

	SetTopPcc( SOCKET0 );

	SetTopPcc( SOCKET1 );
}

void
On_rbtnTool_Pressed( GtkButton *button,gpointer user_data )
{
	ToolSelect = ( int )user_data;
}
