#include	<gtk/gtk.h>
#include	<stdio.h>
#include	"common.h"
#include	"createwidget.h"
#include	"winmsg.h"

int btnValue;

int
Show_Msg( int kind,char *title,char *msg )
{
	GtkWidget	*window;
	GtkWidget	*label;
	GtkWidget	*button1,*button2;
	GtkWidget	*fixed;
	char		*pmsg;
	int 		linecnt = 0,offset = 0;
	Scale		sca;
	Position	pos;

	btnValue = 0;

	pmsg = msg;
	while( *pmsg != 0x00 ) {
		if( *pmsg == 0x0a ) linecnt++;
		pmsg++;
	}
	offset = linecnt * 16;

	/* ١ɥ */
	window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_title( GTK_WINDOW( window ),title );
	gtk_widget_set_usize( window,
						  256,
						  96 + offset );
	gtk_window_set_position( GTK_WINDOW( window ),GTK_WIN_POS_CENTER );
	gtk_window_set_policy( GTK_WINDOW( window ),
						   FALSE,
						   FALSE,
						   FALSE );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( window ),
						"destroy",
						GTK_SIGNAL_FUNC( gtk_main_quit ),
						NULL );

	/* fixed box */
	fixed = CreateFixed( window,"fixed" );
	gtk_container_add( GTK_CONTAINER( window ),fixed );

	/* button */
	sca.width  = NUM_BTN_WIDE_WIDTH;
	sca.height = NUM_BTN_WIDE_HEIGHT;
	pos.y      = NUM_MSG_BTN_Y + offset;

	switch( kind ) {
	case 1:
		pos.x = NUM_MSG_BTN2_X;
		button1 = CreateButton( window,"button1",STR_OK,&sca,&pos,TRUE );
		gtk_fixed_put( GTK_FIXED( fixed ),button1,pos.x,pos.y );
	
		/* signal³ */
		gtk_signal_connect( GTK_OBJECT( button1 ),
							"clicked",
							GTK_SIGNAL_FUNC( On_ShowMsg_Btn_Clicked ),
							( gpointer )1 );
		break;
	case 2:
		pos.x = NUM_MSG_BTN1_X;
		button1 = CreateButton( window,"button1",STR_YES,&sca,&pos,TRUE );
		gtk_fixed_put( GTK_FIXED( fixed ),button1,pos.x,pos.y );
	
		/* signal³ */
		gtk_signal_connect( GTK_OBJECT( button1 ),
							"clicked",
							GTK_SIGNAL_FUNC( On_ShowMsg_Btn_Clicked ),
							( gpointer )1 );

		pos.x = NUM_MSG_BTN2_X;
		button2 = CreateButton( window,"button2",STR_NO,&sca,&pos,TRUE );
		gtk_fixed_put( GTK_FIXED( fixed ),button2,pos.x,pos.y );
	
		/* signal³ */
		gtk_signal_connect( GTK_OBJECT( button2 ),
							"clicked",
							GTK_SIGNAL_FUNC( On_ShowMsg_Btn_Clicked ),
							( gpointer )0 );
		break;
	}

	/* label */
	sca.width  = NUM_LBL_WIDTH;
	sca.height = NUM_LBL_HEIGHT + offset;
	pos.x      = NUM_LBL_X;
	pos.y      = NUM_LBL_Y;

	label = CreateLabel( window,"lblMsg",msg,&sca,&pos,GTK_JUSTIFY_CENTER );
	gtk_fixed_put( GTK_FIXED( fixed ),label,pos.x,pos.y );
	gtk_widget_show( window );
	gtk_grab_add( window );
	gtk_main();

	return btnValue;
}

void
On_ShowMsg_Btn_Clicked( GtkButton *button,gpointer user_data )
{
	btnValue = ( int )user_data;

	gtk_grab_remove( gtk_widget_get_toplevel( GTK_WIDGET( button ) ) );
	gtk_widget_destroy(
		gtk_widget_get_toplevel( GTK_WIDGET( button ) )
	);

	return;
}

void
ShowMsg_Quit( GtkButton *button,gpointer user_data )
{
	gtk_grab_remove( gtk_widget_get_toplevel( GTK_WIDGET( button ) ) );
	gtk_widget_destroy(
		gtk_widget_get_toplevel( GTK_WIDGET( button ) )
	);
}
