#include <gtk/gtk.h>
#include "common.h"
#include "winmain.h"
#include "cb_winmain.h"
#include "wintool.h"

clwindow	winMain;

int
main( int argc,char *argv[] )
{
	/* ¹ԴĶå */

	/* ܸ */
	gtk_set_locale();
	InitApp();								/*add 03/26*/

	/* Gtk */
	gtk_init( &argc,&argv );

	/* ư̺ */
	CreateWintop();

	/* ư̽ */
	InitWintop();

	/* ưɽ */
	gtk_widget_show( winMain.window );

	/* ᥤ롼 */
	gtk_main();

	/* λ */
	return 0;
}

/*
	ư̺
*/
static int
CreateWintop( void )
{
	/* ١ɥ */
	CreateWinbase();

	/* 롼(˥塼) */
	CreateMenu();

	/* 롼(Fdd) */
	CreateFdd();

	/* 롼(Pcc) */
	CreatePcc();

	/* 롼(ġС) */
	CreateToolBar();

	return 0;
}

/*
	١ɥ
*/
static void
CreateWinbase()
{
	GtkWidget	*fixBase;

	winMain.window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_title( GTK_WINDOW( winMain.window ),
						  TITLE_TOP );
	gtk_widget_set_usize( winMain.window,
						  NUM_TOP_WIDTH,
						  NUM_TOP_HEIGHT );
	gtk_window_set_position( GTK_WINDOW( winMain.window ),
							 GTK_WIN_POS_CENTER );
	gtk_window_set_policy( GTK_WINDOW( winMain.window ),
						   FALSE,
						   FALSE,
						   FALSE );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( winMain.window ),
						"destroy",
						GTK_SIGNAL_FUNC( gtk_main_quit ),
						NULL );

	/* fixed box */
	fixBase = CreateFixed( winMain.window,NAME_TOP_FIX );
	gtk_container_add( GTK_CONTAINER( winMain.window ),fixBase );

	return;
}

/*
	롼(˥塼)
*/
static void
CreateMenu()
{
	GtkWidget	*fraMenu;
	GtkWidget	*fixMenu;
	GtkWidget	*btnMenuHelp;
	Scale		sca;
	Position	pos;

	/* frame */
	sca.width  = NUM_TOP_FRAMENU_WIDTH;
	sca.height = NUM_TOP_FRAMENU_HEIGHT;
	pos.x      = NUM_TOP_FRAMENU_X;
	pos.y      = NUM_TOP_FRAMENU_Y;
	fraMenu = CreateFrame( winMain.window,
						   NAME_TOP_FRAMENU,
						   NULL,
						   &sca,&pos,
						   GTK_SHADOW_NONE );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( winMain.window,NAME_TOP_FIX ) ),
										  fraMenu,
										  pos.x,pos.y );

	/* fixMenu */
	fixMenu = CreateFixed( winMain.window,
						   NAME_TOP_FIXMENU );
	gtk_container_add( GTK_CONTAINER( fraMenu ),
					   fixMenu );

	/* btnMenuHelp */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOP_BTNMENUHELP_X;
	pos.y      = NUM_TOP_BTNMENUHELP_Y;
	btnMenuHelp = CreateButton( winMain.window,
								NAME_TOP_BTNMENUHELP,
								STR_HELP,
								&sca,&pos,
								TRUE );
	gtk_fixed_put( GTK_FIXED( fixMenu ),
				   btnMenuHelp,
				   pos.x,pos.y );

	gtk_signal_connect( GTK_OBJECT( btnMenuHelp ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnMenuHelp_Clicked ),
						NULL );

	return;
}

/*
	롼(Fdd)
*/
static void
CreateFdd()
{

	GtkWidget	*fraFdd;
	GtkWidget	*fixFdd;
	GtkWidget	*btnFddStat;
	GtkWidget	*btnFddAfs;
	GtkWidget	*lblFddStat;
	GtkWidget	*lblFddMp;
	GtkWidget	*lblFddMode;
	GtkWidget	*etyFddStat;
	GtkWidget	*etyFddMp;
	GtkWidget	*etyFddMode;
	Scale		sca;
	Position	pos;
	int i;

	/* fraFdd */
	sca.width  = NUM_TOP_FRAFDD_WIDTH;
	sca.height = NUM_TOP_FRAFDD_HEIGHT;
	pos.x	   = NUM_TOP_FRAFDD_X;
	pos.y	   = NUM_TOP_FRAFDD_Y;
	fraFdd = CreateFrame( winMain.window,
						 NAME_TOP_FRAFDD,
						 STR_FLOPPY,
						 &sca,&pos,
						 GTK_SHADOW_ETCHED_IN );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( winMain.window,NAME_TOP_FIX ) ),
										  fraFdd,
										  pos.x,pos.y );

	/* fixFdd */
	fixFdd = CreateFixed( winMain.window,
						 NAME_TOP_FIXFDD );
	gtk_container_add( GTK_CONTAINER( fraFdd ),
					   fixFdd );

	/* btnFddStat */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOP_BTNFDDSTAT_X;
	pos.y      = NUM_TOP_BTNFDDSTAT_Y;
	btnFddStat = CreateButton( winMain.window,
							   NAME_TOP_BTNFDD_STAT,
							   STR_CONFIRM,
							   &sca,&pos,
							   TRUE );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   btnFddStat,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnFddStat ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnFddStat_Clicked ),
						NULL );

	/* btnFddAfs */
	sca.width  = NUM_BTN_AFS_WIDTH;
	sca.height = NUM_BTN_AFS_HEIGHT;
	pos.x      = NUM_TOP_BTNFDDAFS_X;
	pos.y      = NUM_TOP_BTNFDDAFS_Y;
	btnFddAfs = CreateButton( winMain.window,
							   NAME_TOP_BTNFDD_AFS,
							   STR_AFS,
							   &sca,&pos,
							   TRUE );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   btnFddAfs,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnFddAfs ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnFddAfs_Clicked ),
						NULL );

	/* label */
	sca.width  = NUM_LBL_BASIC_WIDTH;
	sca.height = NUM_LBL_BASIC_HEIGHT;

	pos.x = NUM_TOP_LBLFDDSTAT_X;
	pos.y = NUM_TOP_LBLFDDSTAT_Y;
	lblFddStat = CreateLabel( winMain.window,
							  NAME_TOP_LBLFDD_STAT,
							  STR_STAT,
							  &sca,&pos,
							  GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   lblFddStat,
				   pos.x,pos.y );

	pos.x = NUM_TOP_LBLFDDMP_X;
	pos.y = NUM_TOP_LBLFDDMP_Y;
	lblFddMp   = CreateLabel( winMain.window,
							  NAME_TOP_LBLFDD_MP,
							  STR_MP,
							  &sca,&pos,
							  GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   lblFddMp,
				   pos.x,pos.y );

	pos.x = NUM_TOP_LBLFDDMODE_X;
	pos.y = NUM_TOP_LBLFDDMODE_Y;
	lblFddMode = CreateLabel( winMain.window,
							  NAME_TOP_LBLFDD_MODE,
							  STR_MODE,
							  &sca,&pos,
							  GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   lblFddMode,
				   pos.x,pos.y );

	/* entrybox */
	sca.width  = NUM_ETY_BASIC_WIDTH;
	sca.height = NUM_ETY_BASIC_HEIGHT;

	pos.x = NUM_TOP_ETYFDDSTAT_X;
	pos.y = NUM_TOP_ETYFDDSTAT_Y;
	etyFddStat = CreateEntry( winMain.window,
							  NAME_TOP_ETYFDD_STAT,
							  NULL,
							  &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   etyFddStat,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYFDDMP_X;
	pos.y = NUM_TOP_ETYFDDMP_Y;
	etyFddMp   = CreateEntry( winMain.window,
							  NAME_TOP_ETYFDD_MP,
							  NULL,
							  &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   etyFddMp,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYFDDMODE_X;
	pos.y = NUM_TOP_ETYFDDMODE_Y;
	etyFddMode = CreateEntry( winMain.window,
							  NAME_TOP_ETYFDD_MODE,
							  NULL,
							  &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixFdd ),
				   etyFddMode,
				   pos.x,pos.y );

	return;
}

/*
	롼(Pcc)
*/
static void
CreatePcc()
{
	GtkWidget	*fraPcc;
	GtkWidget	*fixPcc;
	GtkWidget	*btnPccStart;
	GtkWidget	*btnPccStop;
	GtkWidget	*lblPccKind;
	GtkWidget	*lblPccStat;
	GtkWidget	*lblPccMp;
	GtkWidget	*lblPccMode;
	GtkWidget	*etyPccKind0;
	GtkWidget	*etyPccStat0;
	GtkWidget	*etyPccMp0;
	GtkWidget	*etyPccMode0;
	GtkWidget	*etyPccKind1;
	GtkWidget	*etyPccStat1;
	GtkWidget	*etyPccMp1;
	GtkWidget	*etyPccMode1;
	GSList		*rbtnGroup = NULL;
	GtkWidget	*rbtnPccS0;
	GtkWidget	*rbtnPccS1;
	Scale		sca;
	Position	pos;
	int i;

	/* fraPcc */
	sca.width  = NUM_TOP_FRAPCC_WIDTH;
	sca.height = NUM_TOP_FRAPCC_HEIGHT;
	pos.x	   = NUM_TOP_FRAPCC_X;
	pos.y	   = NUM_TOP_FRAPCC_Y;
	fraPcc = CreateFrame( winMain.window,
						  NAME_TOP_FRAPCC,
						  STR_PCC,
						  &sca,&pos,
						  GTK_SHADOW_ETCHED_IN );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( winMain.window,NAME_TOP_FIX ) ),
										  fraPcc,
										  pos.x,pos.y );

	/* fixPcc */
	fixPcc = CreateFixed( winMain.window,
						  NAME_TOP_FIXPCC );
	gtk_container_add( GTK_CONTAINER( fraPcc ),
					   fixPcc );

	/* btnPccStart */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOP_BTNPCCSTART_X;
	pos.y      = NUM_TOP_BTNPCCSTART_Y;
	btnPccStart = CreateButton( winMain.window,
							    NAME_TOP_BTNPCC_START,
							    STR_USESTART,
							    &sca,&pos,
							    TRUE );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   btnPccStart,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnPccStart ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnPccStart_Clicked ),
						NULL );

	/* btnPccStop */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOP_BTNPCCEND_X;
	pos.y      = NUM_TOP_BTNPCCEND_Y;
	btnPccStop = CreateButton( winMain.window,
							   NAME_TOP_BTNPCC_STOP,
							   STR_USESTOP,
							   &sca,&pos,
							   TRUE );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   btnPccStop,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnPccStop ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnPccStop_Clicked ),
						NULL );

	/* label */
	sca.width  = NUM_LBL_BASIC_WIDTH;
	sca.height = NUM_LBL_BASIC_HEIGHT;

	pos.x = NUM_TOP_LBLPCCSTAT_X;
	pos.y = NUM_TOP_LBLPCCSTAT_Y;
	lblPccStat = CreateLabel( winMain.window,
							  NAME_TOP_LBLPCC_STAT,
							  STR_STAT,
							  &sca,&pos,
							  GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   lblPccStat,
				   pos.x,pos.y );

	pos.x = NUM_TOP_LBLPCCKIND_X;
	pos.y = NUM_TOP_LBLPCCKIND_Y;
	lblPccKind = CreateLabel( winMain.window,
							  NAME_TOP_LBLPCC_KIND,
							  STR_KIND,
							  &sca,&pos,
							  GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   lblPccKind,
				   pos.x,pos.y );

	pos.x = NUM_TOP_LBLPCCMP_X;
	pos.y = NUM_TOP_LBLPCCMP_Y;
	lblPccMp = CreateLabel( winMain.window,
							NAME_TOP_LBLPCC_MP,
							STR_MP,
							&sca,&pos,
							GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   lblPccMp,
				   pos.x,pos.y );

	pos.x = NUM_TOP_LBLPCCMODE_X;
	pos.y = NUM_TOP_LBLPCCMODE_Y;
	lblPccMode = CreateLabel( winMain.window,
							  NAME_TOP_LBLPCC_MODE,
							  STR_MODE,
							  &sca,&pos,
							  GTK_JUSTIFY_LEFT );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   lblPccMode,
				   pos.x,pos.y );
	/* entrybox */
	sca.width  = NUM_ETY_BASIC_WIDTH;
	sca.height = NUM_ETY_BASIC_HEIGHT;

	/* å0 */
	pos.x = NUM_TOP_ETYPCCSTAT0_X;
	pos.y = NUM_TOP_ETYPCCSTAT0_Y;
	etyPccStat0 = CreateEntry( winMain.window,
							   NAME_TOP_ETYPCC_STAT0,
							   NULL,
							   &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccStat0,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYPCCKIND0_X;
	pos.y = NUM_TOP_ETYPCCKIND0_Y;
	etyPccKind0 = CreateEntry( winMain.window,
							   NAME_TOP_ETYPCC_KIND0,
							   NULL,
							   &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccKind0,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYPCCMP0_X;
	pos.y = NUM_TOP_ETYPCCMP0_Y;
	etyPccMp0 = CreateEntry( winMain.window,
							 NAME_TOP_ETYPCC_MP0,
							 NULL,
							 &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccMp0,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYPCCMODE0_X;
	pos.y = NUM_TOP_ETYPCCMODE0_Y;
	etyPccMode0 = CreateEntry( winMain.window,
							   NAME_TOP_ETYPCC_MODE0,
							   NULL,
							   &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccMode0,
				   pos.x,pos.y );

	/* å1 */
	pos.x = NUM_TOP_ETYPCCSTAT1_X;
	pos.y = NUM_TOP_ETYPCCSTAT1_Y;
	etyPccStat1 = CreateEntry( winMain.window,
							   NAME_TOP_ETYPCC_STAT1,
							   NULL,
							   &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccStat1,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYPCCKIND1_X;
	pos.y = NUM_TOP_ETYPCCKIND1_Y;
	etyPccKind1 = CreateEntry( winMain.window,
							   NAME_TOP_ETYPCC_KIND1,
							   NULL,
							   &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccKind1,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYPCCMP1_X;
	pos.y = NUM_TOP_ETYPCCMP1_Y;
	etyPccMp1 = CreateEntry( winMain.window,
							 NAME_TOP_ETYPCC_MP1,
							 NULL,
							 &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccMp1,
				   pos.x,pos.y );

	pos.x = NUM_TOP_ETYPCCMODE1_X;
	pos.y = NUM_TOP_ETYPCCMODE1_Y;
	etyPccMode1 = CreateEntry( winMain.window,
							   NAME_TOP_ETYPCC_MODE1,
							   NULL,
							   &sca,&pos );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   etyPccMode1,
				   pos.x,pos.y );

	/* radio button */
	sca.width  = NUM_RBTN_BASIC_WIDTH;
	sca.height = NUM_RBTN_BASIC_HEIGHT;

	/*rbtnPccS0*/
	pos.x      = NUM_TOP_RBTNPCCS0_X;
	pos.y      = NUM_TOP_RBTNPCCS0_Y;
	rbtnPccS0 = gtk_radio_button_new_with_label( rbtnGroup,
												 STR_PCCS0 );
	rbtnGroup = gtk_radio_button_group( GTK_RADIO_BUTTON( rbtnPccS0 ) );
	gtk_object_set_data( GTK_OBJECT( winMain.window ),
						 NAME_TOP_RBTNPCC_S0,
						 rbtnPccS0 );
	gtk_widget_set_usize( rbtnPccS0,
						  sca.width,sca.height );
	gtk_widget_set_uposition( rbtnPccS0,
							  pos.x,pos.y );
	gtk_widget_show( rbtnPccS0 );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   rbtnPccS0,
				   pos.x,pos.y );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( rbtnPccS0 ),
						"pressed",
						GTK_SIGNAL_FUNC( On_rbtnPcc_Pressed ),
						( gpointer )0 );

	/*rbtnPccS1*/
	pos.x      = NUM_TOP_RBTNPCCS1_X;
	pos.y      = NUM_TOP_RBTNPCCS1_Y;
	rbtnPccS1 = gtk_radio_button_new_with_label( rbtnGroup,
												 STR_PCCS1 );
	rbtnGroup = gtk_radio_button_group( GTK_RADIO_BUTTON( rbtnPccS1 ) );
	gtk_object_set_data( GTK_OBJECT( winMain.window ),
						 NAME_TOP_RBTNPCC_S1,
						 rbtnPccS1 );
	gtk_widget_set_usize( rbtnPccS1,
						  sca.width,sca.height );
	gtk_widget_set_uposition( rbtnPccS1,
							  pos.x,pos.y );
	gtk_widget_show( rbtnPccS1 );
	gtk_fixed_put( GTK_FIXED( fixPcc ),
				   rbtnPccS1,
				   pos.x,pos.y );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( rbtnPccS1 ),
						"pressed",
						GTK_SIGNAL_FUNC( On_rbtnPcc_Pressed ),
						( gpointer )1 );

	return;
}

/*
	롼(ġС)
*/
static void
CreateToolBar()
{
	GtkWidget	*fraTB;
	GtkWidget	*fixTB;
	GtkWidget	*btnTBTool;
	GtkWidget	*btnTBEnd;
	Scale		sca;
	Position	pos;

	/* fraTB */
	sca.width  = NUM_TOP_FRATB_WIDTH;
	sca.height = NUM_TOP_FRATB_HEIGHT;
	pos.x      = NUM_TOP_FRATB_X;
	pos.y      = NUM_TOP_FRATB_Y;

	fraTB = CreateFrame( winMain.window,
						 NAME_TOP_FRATB,
						 NULL,
						 &sca,&pos,
						 GTK_SHADOW_NONE );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( winMain.window,NAME_TOP_FIX ) ),
										  fraTB,
										  pos.x,pos.y );

	/* fixTB */
	fixTB = CreateFixed( winMain.window,
						 NAME_TOP_FIXTB );
	gtk_container_add( GTK_CONTAINER( fraTB ),
					   fixTB );
	
	/* btnTBTool */
	sca.width  = NUM_BTN_WIDE_WIDTH;
	sca.height = NUM_BTN_WIDE_HEIGHT;
	pos.x      = NUM_TOP_BTNTBTOOL_X;
	pos.y      = NUM_TOP_BTNTBTOOL_Y;
	btnTBTool  = CreateButton( winMain.window,
							   NAME_TOP_BTNTB_TOOL,
							   STR_TOOL,
							   &sca,&pos,
							   TRUE );
	gtk_fixed_put( GTK_FIXED( fixTB ),
				   btnTBTool,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnTBTool ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnTBTool_Clicked ),
						NULL );

	/* btnTBEnd */
	sca.width  = NUM_BTN_WIDE_WIDTH;
	sca.height = NUM_BTN_WIDE_HEIGHT;
	pos.x      = NUM_TOP_BTNTBEND_X;
	pos.y      = NUM_TOP_BTNTBEND_Y;
	btnTBEnd  = CreateButton( winMain.window,
							  NAME_TOP_BTNTB_END,
							  STR_END,
							  &sca,&pos,
							  TRUE );
	gtk_fixed_put( GTK_FIXED( fixTB ),
				   btnTBEnd,
				   pos.x,pos.y );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( btnTBEnd ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnTBEnd_Clicked ),
						NULL );

	return;
}


/*
	ư̽
*/
int
InitWintop( void )
{
	/* եåԡ */
	SetTopFdd();

	/* PC 0*/
	SetTopPcc( SOCKET0 );

	/* PC 1*/
	SetTopPcc( SOCKET1 );

	return 0;
}


/*add 03/26
ץ̤˴ؤ
*/
static void
InitApp(void)
{
/*	setlocale(LC_ALL,"");*/
	bindtextdomain(PACKAGE,LOCALEDIR);
	textdomain(PACKAGE);

	return;
}
